// knopf.h
// AVR-MT128 Olimex
#ifndef KNOPF_H
#define KNOPF_H 1

#define KNOPF_TIME 10 // ms, Zeit zwischen Tastenabfragen

#include "mein_def.h"

void knopf_abfrage(void);
u8 get_key_press( u8 key_mask ); 
// Pruefung Taste gedruckt? 

u8 get_key_rpt( u8 key_mask ); 
// Pruefung lang gedruckt 
// lange gedruckt = schnell zaehlen

// check if a key is pressed right now
u8 get_key_state( u8 key_mask ); 
// Ob Taste gehalten wird 

u8 get_key_short( u8 key_mask ); 
// Ob kurz gedruckt 

u8 get_key_long( u8 key_mask );

//u8 get_key_long_r( u8 key_mask );    
// if repeat function needed

//u8 get_key_rpt_l( u8 key_mask );
// if long function needed


#define KN_OBEN_PORT	PORTA	/* B1 */
#define KN_OBEN_DDR		DDRA
#define KN_OBEN_PIN		PINA
#define KN_OBEN			PA0

#define KN_MINUS_PORT	PORTA	/* B2 */
#define KN_MINUS_DDR	DDRA
#define KN_MINUS_PIN	PINA
#define KN_MINUS		PA1

#define KN_START_PORT	PORTA	/* B3 */
#define KN_START_DDR	DDRA
#define KN_START_PIN	PINA
#define KN_START		PA2

#define KN_PLUS_PORT	PORTA	/* B4 */
#define KN_PLUS_DDR		DDRA
#define KN_PLUS_PIN		PINA
#define KN_PLUS			PA3

#define KN_UNTEN_PORT	PORTA	/* B5 */
#define KN_UNTEN_DDR	DDRA
#define KN_UNTEN_PIN	PINA
#define KN_UNTEN		PA4

#define REPEAT_START    50                   /* after 500ms */
#define REPEAT_NEXT     10                   /* every 200ms */
#define REPEAT_MASK     (1<<KEY_MINUS | 1<<KEY_PLUS | 1<<KEY_OBEN | 1<<KEY_UNTEN | 1<<KEY_START)  /* repeat: key1, key2 */

/* fuer Analyse entprellten Tasten */
#define KEY_OBEN 4 
#define KEY_UNTEN 3 
#define KEY_PLUS 2 
#define KEY_MINUS 1 
#define KEY_START 0 

static inline void knopf_init(void){
	KN_PLUS_DDR &= ~(1<<KN_PLUS);
	KN_MINUS_DDR &= ~(1<<KN_MINUS);
	KN_OBEN_DDR &= ~(1<<KN_OBEN);
	KN_UNTEN_DDR &= ~(1<<KN_UNTEN);
	KN_START_DDR &= ~(1<<KN_START);
	KN_PLUS_PORT |= (1<<KN_PLUS);
	KN_MINUS_PORT |= (1<<KN_MINUS);
	KN_OBEN_PORT |= (1<<KN_OBEN);
	KN_UNTEN_PORT |= (1<<KN_UNTEN);
	KN_START_PORT |= (1<<KN_START);
}

static inline u8 knopf_input(void){ // Lesen von Knopf-Zustand
// abhaengig von Schaltung
	u8 xx = 0xff;

	if(!(KN_PLUS_PIN & (1<<KN_PLUS))) xx &= ~(1<<KEY_PLUS);
	if(!(KN_MINUS_PIN & (1<<KN_MINUS))) xx &= ~(1<<KEY_MINUS);
	if(!(KN_OBEN_PIN & (1<<KN_OBEN))) xx &= ~(1<<KEY_OBEN);
	if(!(KN_UNTEN_PIN & (1<<KN_UNTEN))) xx &= ~(1<<KEY_UNTEN);
	if(!(KN_START_PIN & (1<<KN_START))) xx &= ~(1<<KEY_START);

	return xx;
}

#endif	/* KNOPF_H */ 
