// logik.c
// AVR-MT128 Olimex
#include <avr/io.h>	// Muss immer sein
#include <avr/interrupt.h> 	// Fuer Interrupts
#include <avr/pgmspace.h> 	// Fuer Flash

#include "main.h" 	// Allgemeine Programmablauf
#include "rtos.h"
#include "knopf.h"
#include "logik.h"
#include "lcd.h"
#include "schall.h"

u16 kn_00 = 0;
u16 kn_01 = 0;
u16 kn_02 = 0;
u16 kn_03 = 0;
u16 kn_04 = 0;

void ind_dec5(u16 zahl, u8 platz){
	u8 a=0,b=0,c=0,d=0,e=0;

	while(zahl >= 10000){
		zahl -= 10000;
		a++;
	}

	while(zahl >= 1000){
		zahl -= 1000;
		b++;
	}

	while(zahl >= 100){
		zahl -= 100;
		c++;
	}

	while(zahl >= 10){
		zahl -= 10;
		d++;
	}

	e = (unsigned char)zahl;

	lcd_puff_data((a+48),platz);
	lcd_puff_data((b+48),(platz+1));
	lcd_puff_data((c+48),(platz+2));
	lcd_puff_data((d+48),(platz+3));
	lcd_puff_data((e+48),(platz+4));

	puf_neu();
}


void logik_controlle(void){

	switch(get_key_short(1<<KEY_OBEN | 1<<KEY_UNTEN | 1<<KEY_START)){
		case 1<<KEY_OBEN : SetTask(logik_zahlen,1,10,0); SetTask(schall_ein_knopf,SCHALL_FREQ_E3,100,0); break;
		case 1<<KEY_UNTEN : SetTask(logik_zahlen,1,-10,0); SetTask(schall_ein_knopf,SCHALL_FREQ_A2,100,0); break;
		case 1<<KEY_START : SetTask(logik_zahlen,1,100,0); SetTask(schall_ein_knopf,SCHALL_FREQ_C3,200,0); break;
	}

	switch(get_key_long(1<<KEY_OBEN | 1<<KEY_UNTEN | 1<<KEY_START)){
		case 1<<KEY_OBEN : SetTask(logik_zahlen,2,10,0); SetTask(schall_ein_knopf,SCHALL_FREQ_E3,100,0); break;
		case 1<<KEY_UNTEN : SetTask(logik_zahlen,2,-10,0); SetTask(schall_ein_knopf,SCHALL_FREQ_A2,100,0); break;
		case 1<<KEY_START : SetTask(logik_zahlen,2,100,0); SetTask(schall_ein_knopf,SCHALL_FREQ_C3,200,0); break;
	}

	switch(get_key_press(1<<KEY_PLUS | 1<<KEY_MINUS)){
		case 1<<KEY_PLUS : SetTask(logik_zahlen,0,1,0); SetTask(schall_ein_knopf,SCHALL_FREQ_D3,50,0); break;
		case 1<<KEY_MINUS : SetTask(logik_zahlen,0,-1,0); SetTask(schall_ein_knopf,SCHALL_FREQ_H2,50,0); break;
	}

	switch(get_key_rpt(1<<KEY_PLUS | 1<<KEY_MINUS)){
		case 1<<KEY_PLUS : SetTask(logik_zahlen,0,1,0); SetTask(schall_ein_knopf,SCHALL_FREQ_D3,50,0); break;
		case 1<<KEY_MINUS : SetTask(logik_zahlen,0,-1,0); SetTask(schall_ein_knopf,SCHALL_FREQ_H2,50,0); break;
	}

}

