// main.h
// AVR-MT128 Olimex
// RTOS nach DI_HALT http://easyelectronics.ru
// benutzt typedef aus mein_def.h, Ueberschaubarkeit optimisiert
// Ringpuffer fuer TaskQueue
// die Aufgaben bekommen je 3 Parameter: u16,s16,u8
// Timer 3 macht Klang mit OC3B und OC3C, FastPWM, OCR3A = Frequenz, OCR3B und OCR3C bestimmen Verhaeltnis
#ifndef MAIN_H
#define MAIN_H 

#ifndef F_CPU 
   #define F_CPU 16000000UL		/* 16 MHz */
#endif 

#include "mein_def.h"

// Prototypen Aufgaben ============================================================
//void lcd_automat(void);	/* LCD-Puffer nach LCD kopieren */
void knopf_abf(void);	/* Tastenabfrage starten */
void logik_k(void);	/* Tastenanalyse, 10 ms (KNOPF_TIME) */

void logik_zahlen(void);	// PA_puff.par0 = Variable, PA_puff.par1 = Wert zu addieren

void schall_ein_knopf(void);	// PA_puff.par0 = u16 freq, PA_puff.par1 = s16 time
void schall_aus(void);

//============================================================================

/*********** Aufgaben Variablen ***************************/

/*********************************************************/


//======== HAL =============================================== 
#define RELAY_DDR	DDRA	/* Relay */
#define RELAY_PORT	PORTA
#define RELAY_PIN	PINA
#define RELAY_		PA6 
/**************************************************************/ 

#endif /*  MAIN_H  */
