// mein_def.h
#ifndef MEIN_DEF_H

#define MEIN_DEF_H

typedef uint8_t   u8;

typedef  int8_t   s8;

typedef uint16_t  u16;

typedef  int16_t  s16;

typedef uint32_t  u32;

typedef  int32_t  s32;
typedef uint64_t  u64;
typedef  int64_t  s64;
typedef __uint24  u24;
typedef  __int24  s24;


/* Macro */



#define mein_def_delms(x) (mein_def_delayloop24((x*(F_CPU/5000))-1))  

/* x, ms, fuer delayloop24 */

		/* max. bei  F_CPU= 20 MHz 4194, d.h. 4,194 s. */

		/* max. bei  F_CPU= 16 MHz 5242, d.h. 5,242 s. */

		/* max. bei  F_CPU= 10 MHz 8388, d.h. 8,388 s. */

		/* max. bei  F_CPU=  8 MHz 10485, d.h. 10,485 s. */

		/* max. bei  F_CPU=  5 MHz 16777, d.h. 16,777 s. */

		/* max. bei  F_CPU=  4 MHz 20971, d.h. 20,971 s. */

		/* max. bei  F_CPU= 2,5 MHz 33554, d.h. 33,554 s. */

		/* max. bei  F_CPU=  2 MHz 41943, d.h. 41,943 s. */

		/* max. bei  F_CPU= 1,25 MHz 67108, d.h. 1 min. 7,108 s. */

		/* max. bei  F_CPU=  1 MHz 83886, d.h. 1 min. 23,886 s. */

			/* Beispiel: 	asm volatile("nop");

							mein_def_delms(1000);

							asm volatile("nop"); // 1,0 s */



#define mein_def_delmks(x) (mein_def_delayloop16(((x*(F_CPU/100UL))/40000UL)-1))  

/* x, us, fuer delayloop16 */

		/* max. bei  F_CPU= 20 MHz 13107, d.h. 13,107 ms */

		/* max. bei  F_CPU= 16 MHz 16383, d.h. 16,383 ms */

		/* max. bei  F_CPU= 10 MHz 26214, d.h. 26,2144 ms */

		/* max. bei  F_CPU=  8 MHz 32767, d.h. 32,767 ms */

		/* max. bei  F_CPU=  5 MHz 52428, d.h. 52,428 ms */

		/* max. bei  F_CPU=  4 MHz 65535, d.h. 65,535 ms */

		/* max. bei  F_CPU= 2,5 MHz 104856, d.h. 104,856 ms */

		/* max. bei  F_CPU=  2 MHz 131070, d.h. 131,07 ms */

		/* max. bei  F_CPU= 1,25 MHz 209712, d.h. 209,712 ms */

		/* max. bei  F_CPU= 1 MHz 262140, d.h. 262,140 ms */

			/* Beispiel: 	asm volatile("nop");

							mein_def_delmks(13000);

							asm volatile("nop"); // 13 ms */



#define mein_def_delcycle(x) (mein_def_delayloop8(((x*(F_CPU/3UL))/10000000UL)-1)) 

/* x, 10*us, fuer delayloop8 */

		/* max.384, d.h.  bei  F_CPU= 20 MHz 38,4 us */

		/* max.480, d.h.  bei  F_CPU= 16 MHz 48,0 us */

		/* max.768, d.h.  bei  F_CPU= 10 MHz 76,8 us */

		/* max.960, d.h.  bei  F_CPU=  8 MHz 96,0 us */

		/* max.1536, d.h.  bei  F_CPU=  5 MHz 153,6 us */

		/* max.1920, d.h.  bei  F_CPU=  4 MHz 192,0 us */

		/* max.3072, d.h.  bei  F_CPU= 2,5 MHz 307,2 us */

		/* max.3840, d.h.  bei  F_CPU=  2 MHz 384,0 us */

		/* max.6144, d.h.  bei  F_CPU= 1,25 MHz 614,4 us */

		/* max.7680, d.h.  bei  F_CPU=  1 MHz 768,0 us */

			/* Beispiel: 	asm volatile("nop");

							mein_def_delcycle(300);

							asm volatile("nop"); // 30 us */



/* Prototype Inline-Funktionen */



static inline void __attribute__((always_inline))

mein_def_delayloop8 (unsigned char count); 

/* Die Schleife dauert  3 * count + 3  Ticks */

/* bei F_CPU 10 MHz max 76,8 mcs */



static inline void __attribute__((always_inline))

mein_def_delayloop16 (unsigned int count);

/* Die Schleife dauert  4 * count + 4  Ticks */

/* bei F_CPU 10 MHz max 26,2144 ms */



static inline void __attribute__((always_inline))

mein_def_delayloop24 (unsigned long count);

/* Die Schleife dauert  5 * count + 6  Ticks */

/* bei F_CPU 10 MHz max 8,3886 s */



static inline unsigned char __attribute__((always_inline))

mein_def_swap (unsigned char x);
/* Beispiel: PORTC = mein_def_swap(PORTC); */



/* Beispiel:

PORTD = mein_def_swap(PORTD);

mein_def_delayloop8(100);

asm volatile("nop");

mein_def_delayloop16(2500);

PORTD++;

mein_def_delayloop24(100500);

PORTC++;
PORTC = mein_def_swap(PORTC);

 */



/* Inline-Funktionen */



static inline void __attribute__((always_inline))

mein_def_delayloop8 (unsigned char count)

{

	/* Die Schleife dauert  3 * count + 3  Ticks */

	/* bei F_CPU 10 MHz max 76,8 mcs */

	asm volatile ("1:"           "\n\t"

		      "subi %A0,1" "\n\t"

		      "brcc 1b"

		      : "+d" (count));

}





static inline void __attribute__((always_inline))

mein_def_delayloop16 (unsigned int count)

{

    /* Die Schleife dauert  4 * count + 4  Ticks */

	/* bei F_CPU 10 MHz max 26,2144 ms */



    asm volatile ("1:"           "\n\t"

                  "sbiw %0,1"    "\n\t"

                  "brcc 1b"

                  : "+w" (count));

}



static inline void __attribute__((always_inline))

mein_def_delayloop24 (unsigned long count)

{

   /* Die Schleife dauert  5 * count + 6  Ticks */

	/* bei F_CPU 10 MHz max 8,3886 s */

	asm volatile ("1:"	   "\n\t"

		      "subi %A0,1" "\n\t"

		      "sbci %B0,0" "\n\t"

		      "sbci %C0,0" "\n\t"

		      "brcc 1b"

		      : "+d" (count));

}



static inline unsigned char __attribute__((always_inline))

mein_def_swap (unsigned char x)

{

    asm ("swap %0" : "+r" (x));

    return x;

}
/* Beispiel: PORTA = mein_def_swap(PORTA); */

#endif /*  MEIN_DEF_H  */
