// rtos.h
// 2018.11.20
// RTOS nach DI_HALT http://easyelectronics.ru
// benutzt typedef aus mein_def.h, Ueberschaubarkeit optimisiert
// Ringpuffer fuer TaskQueue
// die Aufgaben bekommen je 3 Parameter: u16,s16,u8
#ifndef RTOS_H
#define RTOS_H

#include "mein_def.h"

/* Beispiele */
/* Eine Aufgabe knopf_abf in die Reihe zu stellen: SetTask(knopf_abf,var_u16,var_s16,var_u8); */
/* Eine Aufgabe logik_k in Timerreihe zu stellen: SetTimerTask(logik_k,(KNOPF_TIME/2),var_u16,var_s16,var_u8); */

//========== RTOS_HAL ==================================

#define	TaskQueueSize		20
#define MainTimerQueueSize	20

/********************************************************/
/*** Fuer Parameter Uebergabe an die Aufgaben ***********/
/********************************************************/
extern struct ParAufgabe{			/* Puffer fuer Aufgaben */
				u16 par0;
				s16 par1;
				u8  par2;
				} PA_puff;

/*******************************************************/

//extern void RunRTOS (void);

static inline void RunRTOS(void){
// init_timer2
	TCNT2 = 0;
	OCR2 = 249;	// Fin/250 
	TIMSK = (1<<OCIE2); // Interrupt 
	TCCR2 = (1<<WGM21)|(1<<CS21)|(1<<CS20); // CTC, 1/64  Ftimer0 = 1 kHz
//sei();
	SREG |= (1<<SREG_I);
}

//=========== RTOS =====================================

extern void InitRTOS(void);	// RTOS Vorbereitung. Reihen auf Null
extern void Idle(void);	// Leerlauf 

typedef void (*TPTR)(void);

extern void SetTask(TPTR TS,u16 par0, s16 par1, u8 par2);
extern void SetTimerTask(TPTR TS, u16 NewTime,u16 par0, s16 par1, u8 par2);

extern void TaskManager(void);
extern void TimerService(void);

//====================================================== 

#endif /*  RTOS_H  */
