// schall.h
// Timer 3 macht Klang mit OC3B und OC3C, FastPWM, OCR3A = Frequenz, OCR3B und OCR3C bestimmen Verhaeltnis
#ifndef SCHALL_H
#define SCHALL_H 

#include "mein_def.h"

#define SCHALL_DDR	DDRE
#define SCHALL_PORT	PORTE
#define SCHALL_1	PE4
#define SCHALL_2	PE5

#define SCHALL_EIN	(TCCR3B |= (1<<CS30))
#define SCHALL_AUS	(TCCR3B &= ~(1<<CS30))

#define SCHALL_FREQ_C2	2093
#define SCHALL_FREQ_Cs2	2217
#define SCHALL_FREQ_D2	2349
#define SCHALL_FREQ_Ds2	2489
#define SCHALL_FREQ_E2	2637
#define SCHALL_FREQ_F2	2794
#define SCHALL_FREQ_Fs2	2960
#define SCHALL_FREQ_G2	3136
#define SCHALL_FREQ_Gs2	3322
#define SCHALL_FREQ_A2	3520
#define SCHALL_FREQ_B2	3729
#define SCHALL_FREQ_H2	3951
#define SCHALL_FREQ_C3	4186
#define SCHALL_FREQ_Cs3	4435
#define SCHALL_FREQ_D3	4699
#define SCHALL_FREQ_Ds3	4978
#define SCHALL_FREQ_E3	5274
#define SCHALL_FREQ_F3	5588
#define SCHALL_FREQ_Fs3	5920
#define SCHALL_FREQ_G3	6272
#define SCHALL_FREQ_Gs3	6645
#define SCHALL_FREQ_A3	7040
#define SCHALL_FREQ_B3	7459
#define SCHALL_FREQ_H3	7902
#define SCHALL_FREQ_C4	8372

static inline void schall_init(void){
	u16 freq;

	SCHALL_PORT &= ~(1<<SCHALL_1);
	SCHALL_PORT |= (1<<SCHALL_2);
	SCHALL_DDR |= (1<<SCHALL_1);
	SCHALL_DDR |= (1<<SCHALL_2);

	TCNT3 = 0;

		/* Fast-PWM, TOP= OC3A, OC3B ninv, OC3C inv. OC3A=FREQ, OC3B=OC3C=OC3A/2 */
	TCCR3A = (1<<COM3B1)|(1<<COM3C1)|(1<<COM3C0)|(1<<WGM30)|(1<<WGM31); // OC3B, OC3C
	TCCR3B = (1<<WGM32)|(1<<WGM33);	// PWM 		Einschalten = TCCR3B |= (1<<CS30)
										//		Ausschalten = TCCR3B &= ~(1<<CS30)
	freq = ((F_CPU / SCHALL_FREQ_C3) -1);
	OCR3A = freq;
	OCR3B =	(freq / 2);
	OCR3C = (freq / 2);
}

void schall_freq_einstellung(u16 frequenz);

#endif /*  SCHALL_H  */
